<template>
  <a-modal
    :title="title"
    :width="width"
    :bodyStyle="bodyStyle"
    :visible="visible"
    :confirmLoading="confirmLoading"
    @ok="handleOk"
    @cancel="handleCancel"
    :footer="null"
    cancelText="关闭">
    <a-spin :spinning="confirmLoading">
      <a-form :form="form">

        <a-form-item label="服务商" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <template v-if="!model.id">
            <a-input-search
              placeholder="选择服务商"
              disabled
              v-decorator="[ 'subcontractorName', validatorRules.subcontractorId]"
              @search="onSearch">
              <a-button slot="enterButton" icon="search" v-if="!model.id">选择</a-button>
            </a-input-search>
          </template>
          <template v-else>
            <a-input v-decorator="[ 'subcontractorName',{rules: [{ required: true, message: '请选择服务商' }],initialValue:model.subcontractorName}]"  :disabled="true"></a-input>
          </template>
        </a-form-item>

        <a-form-item label="服务费率" :labelCol="labelCol" :wrapperCol="wrapperCol">
          <a-input-number :min="0.01" :max="99.99" v-decorator="[ 'serviceRate', validatorRules.serviceRate]"
                          :formatter="value => `${value}%`" :parser="value => value.replace('%', '')" :precision="2"
                          placeholder="请输入服务费率"
                          style="width: 100%"/>
        </a-form-item>

        <!--<template v-if="model.subcontractorId ||  this.selectedDepartKeys[0]!=null">-->
          <!--<a-form-item label="打款银行" :labelCol="labelCol" :wrapperCol="wrapperCol" :required="true">-->
            <!--<a-checkbox-group :options="plainOptions"  v-model="valueInfo" @change="onChange" />-->
          <!--</a-form-item>-->
        <!--</template>-->



        <!--<a-form-item label="企业合同" :labelCol="labelCol" :wrapperCol="wrapperCol">-->
          <!--<a-upload-->
            <!--name="file"-->
            <!--:multiple="true"-->
            <!--:remove="handleDelete"-->
            <!--:action="uploadAction"-->
            <!--:headers="headers"-->
            <!--:data="{'isup':1,'bizPath':bizPath}"-->
            <!--:fileList="fileList"-->
            <!--:beforeUpload="beforeUpload"-->
            <!--@change="handleChange">-->
            <!--<a-button> <a-icon type="upload" /> 选择上传 </a-button>-->
          <!--</a-upload>-->
        <!--</a-form-item>-->


      </a-form>
    </a-spin>
    <div class="drawer-bootom-button" v-show="!disableSubmit">
      <a-button class="ant-btn"  @click="handleCancel">取消</a-button>
      <a-button class="ant-btn ant-btn-primary" style="margin-left: 8px"  @click="handleOk">确定</a-button>
    </div>
    <company-subcontractor-window ref="companyWindow" @ok="modalFormOk"></company-subcontractor-window>
  </a-modal>
</template>

<script>

  import Vue from 'vue'
  import { ACCESS_TOKEN } from '@/store/mutation-types'
  import { httpAction,getAction, deleteAction, putAction, postAction,downFile } from '@/api/manage'
  import JUpload from '@/components/jeecg/JUpload'
  import pick from 'lodash.pick'
  // 引入搜索服务商弹出框的组件
  import CompanySubcontractorWindow from './CompanySubcontractorWindow'

  const FILE_TYPE_ALL = "all"
  const FILE_TYPE_PDF = 'pdf'
  const uidGenerator = () => {
    return '-' + parseInt(Math.random() * 10000 + 1, 10)
  }
  const getFileName = (path) => {
    if (path.lastIndexOf('\\') >= 0) {
      let reg = new RegExp('\\\\', 'g')
      path = path.replace(reg, '/')
    }
    return path.substring(path.lastIndexOf('/') + 1)
  }

  export default {
    name: "HlgCompanySubcontractorModal ",
    components: {
      CompanySubcontractorWindow
    },
    data () {
      return {
        plainOptions:[],
        valueInfo:[],
        headers: {},
        fileList: [],
        form: this.$form.createForm(this),
        title:"操作",
        width:800,
        bodyStyle: {
          paddingTop: '20px',
          paddingBottom:'50px',
          height: (window.innerHeight * 0.42) + 'px',
          'overflow-y': 'auto'
        },
        disableSubmit:false,
        visible: false,
        model: {},
        labelCol: {
          xs: { span: 24 },
          sm: { span: 5 },
        },
        wrapperCol: {
          xs: { span: 24 },
          sm: { span: 16 },
        },
        selectedDepartKeys:[], //保存用户选择服务商id
        checkedDepartKeys:[],
        confirmLoading: false,
        platformId:0,
        companyId: 0,
        validatorRules:{
          subcontractorId:{rules: [{ required: true, message: '请输入服务商!' }]},
          serviceRate:{rules: [{ required: true, message: '请输入服务费率!' }]},
          serviceContract:{}
        },
        url: {
          add: "/hlgcompany/hlgCompany/companySubcontractorAdd",
          edit: "/hlgcompany/hlgCompany/companySubcontractoredit",
          fileUpload: window._CONFIG['domianURL'] + '/hpSys/common/ossUpload',
          imgerver: window._CONFIG['imgDomainOssURL'],
          queryBankInfo: "/hlgsubcontractor/hlgSubcontractorBankInformation/queryBankInfo",
        }
     
      }
    },
    props: {
      fileType: {
        type: String,
        required: false,
        default: FILE_TYPE_ALL
      },
      /*这个属性用于控制文件上传的业务路径*/
      bizPath: {
        type: String,
        required: false,
        default: '/hlgjob/hlgSubContract'
      },
    },
    created () {
      const token = Vue.ls.get(ACCESS_TOKEN)
      this.headers = { 'X-Access-Token': token }
    },
    computed: {
      uploadAction: function() {
        return this.url.fileUpload
      }
    },
    methods: {
      add (record) {
        this.edit(record);
      },
      edit (record) {
        this.form = this.$form.createForm(this)
        this.form.resetFields();
        this.model={}
        this.model = Object.assign({}, record);
        this.companyId = this.model.companyId;
        this.platformId=this.model.platformId;
        this.plainOptions=[],
        this.valueInfo=[]
        // if(this.model.id){
        //   this.queryBankInfo();
        // }
        this.visible = true;
        this.$nextTick(() => {
          this.form.setFieldsValue(pick(this.model,'companyId','subcontractorId','bankIds','serviceRate','sysOrgCode','createTime','createBy','updateTime','updateBy','isLock','serviceContract','subcontractorName'))
        })
        // this.editFileList(this.model.serviceContract)
        this.selectedDepartKeys = [];
        this.checkedDepartKeys = [];
      },
      close () {
        this.$emit('close');
        this.visible = false;
        this.selectedDepartKeys = [];
        this.checkedDepartKeys = [];
      },
      handleOk () {
        // console.log(1111112,this.model.bankIds)
        // if(!this.model.bankIds){
        //   this.$message.error('请选择打款银行');
        //   return
        // }
        const that = this;
        const { fileList } = that
        // 触发表单验证
        this.form.validateFields((err, values) => {
          if (!err) {
            that.confirmLoading = true;
            let httpurl = '';
            let method = '';
            if(!this.model.id){
              httpurl+=this.url.add;
              method = 'post';
            }else{
              httpurl+=this.url.edit;
               method = 'put';
            }
            // var serviceContract = "";
            let formData = Object.assign(this.model, values);
            if(this.selectedDepartKeys[0]){
              formData.subcontractorId = this.selectedDepartKeys[0].substring(0,1);
              formData.cpType = this.selectedDepartKeys[0].substring(2,3);
            }
            formData.companyId = this.companyId;
            // let isDone = true;
            // fileList.forEach((file,index) => {
            //   if(!file.thUrl){
            //     isDone = false;
            //   }
            //   if(index === 0){
            //     serviceContract = file.thUrl;
            //   }else{
            //     serviceContract += "," + file.thUrl;
            //   }
            // });
            // //上传文件出错
            // if(!isDone){
            //   that.$message.error("正在上传，请稍后提交!");
            //   that.confirmLoading = false
            //   return;
            // }
            // formData.serviceContract = serviceContract;
            console.log("表单提交数据",formData)
            httpAction(httpurl,formData,method).then((res)=>{
              if(res.success){
                that.$message.success(res.message);
                that.$emit('ok');
              }else{
                that.$message.warning(res.message);
              }
            }).finally(() => {
              that.confirmLoading = false;
              that.close();
            })
          }
         
        })
      },
      //搜索服务商
      onSearch(){
        this.$refs.companyWindow.add(this.checkedDepartKeys,this.platformId);
      },
      handleCancel () {
        this.close()
      },
      // 获取用户选择服务商弹提交的返回数据
      modalFormOk (formData) {
        this.selectedDepartKeys = [];
        for (let i = 0; i < formData.departIdList.length; i++) {
          this.selectedDepartKeys.push(formData.departIdList[i].key+","+formData.departIdList[i].cpType);
          this.form.setFieldsValue({ subcontractorName: formData.departIdList[i].title })
        }
        this.checkedDepartKeys = this.selectedDepartKeys  //更新当前的选择keys
        if(this.selectedDepartKeys[0]){
          this.model.bankIds=null
          this.plainOptions=[]
            this.valueInfo=[]
          // this.queryBankInfo()
        }
      },



      handlePathChange() {
        let uploadFiles = this.fileList
        let path = ''
        if (!uploadFiles || uploadFiles.length == 0) {
          path = ''
        }
        let arr = []

        for (var a = 0; a < uploadFiles.length; a++) {
          arr.push(uploadFiles[a].response.message)
        }
        if (arr.length > 0) {
          path = arr.join(',')
        }
        this.$emit('change', path)
        console.log(1111,this.fileList)
      },



      beforeUpload: function(file) {
        //TODO 验证文件大小
      },

      handleChange(info) {
        let fileList = info.fileList
        if (info.file.status === 'done') {
          if (info.file.response.success) {
            fileList = fileList.map((file) => {
              if (file.response) {
                file.url = this.url.imgerver + file.response.message
                file.thUrl = file.response.message
              }
              return file
            })
          }
          this.$message.success(`${info.file.name} 上传成功!`)
        }else if (info.file.status === 'error') {
          this.$message.error(`${info.file.name} 上传失败.`)
        } else if (info.file.status === 'removed') {
          this.handleDelete(info.file)
        }
        this.fileList = fileList
      },

      //移除文件
      handleDelete(file){
        const index = this.fileList.indexOf(file);
        const newFileList = this.fileList.slice();
        newFileList.splice(index, 1);
        this.fileList = newFileList;
      },


      //回显文件所用
      editFileList(paths) {
        if (!paths || paths.length == 0) {
          //return [];
          // update-begin- --- author:os_chengtgen ------ date:20190729 ---- for:issues:326,Jupload组件初始化bug
          this.fileList = []
          return
          // update-end- --- author:os_chengtgen ------ date:20190729 ---- for:issues:326,Jupload组件初始化bug
        }
        let fileList = []
        let arr = paths.split(',')
        for (var a = 0; a < arr.length; a++) {
          fileList.push({
            uid: uidGenerator(),
            name: getFileName(arr[a]),
            status: 'done',
            url: this.url.imgerver +  arr[a],
            thUrl: arr[a]
          })
        }
        this.fileList = fileList
      },
      //查询打款信息配置的所有银行信息数据
      queryBankInfo(){
        var that=this
        var subcontractorId=that.model.subcontractorId
        if(!subcontractorId){
          if(that.selectedDepartKeys[0]){
            subcontractorId = that.selectedDepartKeys[0];
          }
        }
        getAction(that.url.queryBankInfo,{subcontractorId:subcontractorId}).then((res)=>{
          if(res.success){
              if(res.result.length>0){
                for (let i = 0; i <res.result.length ; i++) {
                  var arr={label: res.result[i].bankName+res.result[i].bankAccount.substring(res.result[i].bankAccount.length-4), value: res.result[i].id}
                  that.plainOptions.push(arr)
                }
                if(that.model.bankIds){
                  var arr=that.model.bankIds.split(",")
                  for (let i = 0; i <arr.length ; i++) {
                    that.valueInfo.push(parseInt(arr[i]))
                  }
                }
              }
          }
        });
      },
      onChange(checkedValues){
        if(checkedValues.length>0){
          for (let i = 0; i <checkedValues.length ; i++) {
            if(i==0){
              this.model.bankIds=checkedValues[0]
            }else{
              this.model.bankIds=this.model.bankIds+","+checkedValues[i]
            }
          }
        }else{
          this.model.bankIds=null
        }
      }
    }
  }
</script>
<style>
  .drawer-bootom-button {
    position: absolute;
    bottom: -8px;
    width: 100%;
    border-top: 1px solid #e8e8e8;
    padding: 10px 16px;
    text-align: right;
    left: 0;
    background: #fff;
    border-radius: 0 0 2px 2px;
  }
  .avatar-uploader > .ant-upload {
    width: 104px;
    height: 104px;
  }

  .ant-upload-select-picture-card i {
    font-size: 49px;
    color: #999;
  }

  .ant-upload-select-picture-card .ant-upload-text {
    margin-top: 8px;
    color: #666;
  }
</style>